models/Contacto.php
<?php
namespace app\models;

use Yii;
use yii\base\Model;
use yii\base\ErrorException;

Class Contacto extends Model{
    
    public $nombre;
    public $email;
    public $telefono;
    public $direccion;
    public $asunto;
    public $fecha;
    public $politicas;
    
    public function attributeLabels(): array {
        return [
            "nombre" => "Nombre completo",
            "email" => "Correo electronico",
            "telefono" => "Telefono",
            "direccion" => "Direccion completa",
            "asunto" => "¿Cual es tu pregunta?",
            "fecha" => "Fecha de nacimiento",
            "politicas" => "Aceptar politicas de privacidad",
        ];
    }
    
    public function rules(){
        return[
           [["nombre","email","telefono"],"required"],
            ["email","email"],
            ["nombre","string","length"=>[1,100]],
            ["politicas","boolean"],
            ["fecha","string"],
          [["nombre","email","telefono","direccion","asunto","fecha","politicas"],"safe"]  ,
            ["politicas","comprobarpoliticas"],
        ];
    }
    
    public function comprobarpoliticas($attribute,$params)
    {
        if($this->$attribute==0)
        {
            $this->addError($attribute,"Es necesario que aceptes las politicas de privacidad");
        }
    }
    
    public function contact()
    {
        if ($this->validate()) {
            Yii::$app->mailer->compose()
                ->setTo(Yii::$app->params['contacto'])
                ->setFrom([Yii::$app->params['senderEmail'] => Yii::$app->params['senderName']])
                ->setReplyTo([$this->email => $this->nombre])
                ->setSubject("contacto")
                ->setTextBody($this->asunto)
                ->send();

            return true;
        }
        return false;
    }

    
}

models/Productos.php
<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "productos".
 *
 * @property int $id
 * @property string|null $nombre
 * @property string|null $foto
 * @property string|null $descripcion
 * @property float|null $precio
 * @property int|null $oferta
 * @property string|null $categoria
 */
class Productos extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'productos';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['precio'], 'number'],
            [['oferta'], 'integer'],
            [['nombre', 'foto', 'categoria'], 'string', 'max' => 30],
            [['descripcion'], 'string', 'max' => 100],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'nombre' => 'Nombre',
            'foto' => 'Foto',
            'descripcion' => 'Descripcion',
            'precio' => 'Precio',
            'oferta' => 'Oferta',
            'categoria' => 'Categoria',
        ];
    }
}

controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\Contacto;
use app\models\Productos;
use yii\data\ActiveDataProvider;
use yii\helpers\Html;
use yii\helpers\ArrayHelper;

class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }

    /**
     * Login action.
     *
     * @return Response|string
     */
    public function actionLogin()
    {
        if (!Yii::$app->user->isGuest) {
            return $this->goHome();
        }

        $model = new LoginForm();
        if ($model->load(Yii::$app->request->post()) && $model->login()) {
            return $this->goBack();
        }

        $model->password = '';
        return $this->render('login', [
            'model' => $model,
        ]);
    }

    /**
     * Logout action.
     *
     * @return Response
     */
    public function actionLogout()
    {
        Yii::$app->user->logout();

        return $this->goHome();
    }

    public function actionContacto()
{
    $model = new \app\models\Contacto();

    if ($model->load(Yii::$app->request->post())) {
        if ($model->contact()) {
            
                return $this->render("mostrar");
        }
    }

    return $this->render('contacto', [
        'model' => $model,
    ]);
}

    /**
     * Displays about page.
     *
     * @return string
     */
    public function actionAbout()
    {
        return $this->render('about');
    }
    
    public function actionOfertas()
    {
        $dataProvider = new ActiveDataProvider([
        'query' => Productos::find()->where(["oferta"=>1])]);
        return $this->render("ofertas",["dataProvider" => $dataProvider]);
    }
    
    public function actionProductos()
    {
        $dataProvider = new ActiveDataProvider([
        'query' => Productos::find()]);
        return $this->render("productos",["dataProvider" => $dataProvider]);
    }
    
    public function actionCategorias()
    {
        $resultado=Productos::find()->select("categoria")->distinct()->all();
        return $this->render("categorias",["resultado"=>$resultado]);
    }
    
    public function actionCategoria2($categoria)
    {
        $dataProvider = new ActiveDataProvider([
        'query' => Productos::find()->where(['categoria'=>$categoria])]);
        return $this->render("productos",["dataProvider" => $dataProvider]);
    }
    
    public function actionDondeestamos()
    {
        return $this->render('donde_estamos');
    }
    
    public function actionQuienessomos()
    {
        return $this->render('quienes_somos');
    }
    
    public function actionNuestrosproductos()
    {
        $fotos= Productos::find()
                ->select('foto')
                ->where(["oferta"=>1])
                ->asArray()
                ->all();
        
        $fotos= ArrayHelper::getColumn($fotos,"foto");
        $salida=[];
        foreach($fotos as $src)
        {
            $salida[]= Html::img("@web/img/$src");
        }
        return $this->render('nuestros_productos',["fotos"=>$salida]);
    }
    
    public function actionInformacion()
    {
        return $this->render('informacion');
    }
    
    public function actionVermas($id)
    {
        $salida=Productos::findOne($id);
        
        return $this->render('vermas',["model"=>$salida]);
    }
}

views/layouts/main.php
<?php

/* @var $this \yii\web\View */
/* @var $content string */

use app\assets\AppAsset;
use app\widgets\Alert;
use yii\bootstrap4\Breadcrumbs;
use yii\bootstrap4\Html;
use yii\bootstrap4\Nav;
use yii\bootstrap4\NavBar;

AppAsset::register($this);
?>
<?php $this->beginPage() ?>
<!DOCTYPE html>
<html lang="<?= Yii::$app->language ?>" class="h-100">
<head>
    <meta charset="<?= Yii::$app->charset ?>">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <?php $this->registerCsrfMetaTags() ?>
    <title><?= Html::encode($this->title) ?></title>
    <?php $this->head() ?>
</head>
<body class="d-flex flex-column h-100">
<?php $this->beginBody() ?>

<header>
    <?php
    NavBar::begin([
        'brandLabel' => Yii::$app->name,
        'brandUrl' => Yii::$app->homeUrl,
        'options' => [
            'class' => 'navbar navbar-expand-md navbar-dark bg-dark fixed-top',
        ],
    ]);
    echo Nav::widget([
        'options' => ['class' => 'navbar-nav'],
        'encodeLabels' => false, //para que funcionen los dibujos del menu
        'items' => [
            ['label' => '<i class="fas fa-house-user"></i> Inicio', 'url' => ['/site/index']],
            ['label' => '<i class="fa fa-check" aria-hidden="true"> </i>
            Ofertas', 'url' => ['/site/ofertas']],
            ['label' => '<i class="fas fa-cube"></i> Productos', 'url' => ['/site/productos']],
            ['label' => 'Categorias', 'url' => ['/site/categorias']],
            ['label' => 'Nosotros', 'items' =>[
                ['label' => 'Donde Estamos', 'url' => ['/site/dondeestamos']],
                ['label' => 'Quienes Somos', 'url' => ['/site/quienessomos']],
                ['label' => 'Nuestros productos', 'url' => ['/site/nuestrosproductos']],
                '<div class="dropdown-divider"></div>',
                ['label' => 'Informacion', 'url' => ['/site/informacion']]]],    
            ['label' => 'Contacto', 'url' => ['/site/contacto']],
        ],
    ]);
    NavBar::end();
    ?>
</header>

<main role="main" class="flex-shrink-0">
    <div class="container">
        <?= Breadcrumbs::widget([
            'links' => isset($this->params['breadcrumbs']) ? $this->params['breadcrumbs'] : [],
        ]) ?>
        <?= Alert::widget() ?>
        <?= $content ?>
    </div>
</main>

<footer class="footer mt-auto py-3 text-muted">
    <div class="container">
        <p class="float-left">&copy; My Company <?= date('Y') ?></p>
        <p class="float-right"><?= Yii::powered() ?></p>
    </div>
</footer>

<?php $this->endBody() ?>
</body>
</html>
<?php $this->endPage() ?>

views/site/_ofertas.php
<?php
use yii\helpers\Html;
?>

<table>
    <tr><td rowspan="6"><?= Html::img('@web/img/' . $model->foto,['class'=>'img-fluid', 'style'=>'width:300px'])?></td><td><?= "Id: " . $model->id ?></td></tr>
    <tr><td><?= "Nombre: " . $model->nombre ?></td></tr>
    <tr><td><?= "Descripcion: " . substr($model->descripcion,0,5) . "..."?></td></tr>
    <tr><td><?= "Precio: " . $model->precio . "€"?></td></tr>
    <tr><td><?= "Oferta: " . $model->oferta ?></td></tr>
    <tr><td><?= "Categoria: " . $model->categoria  ?></td></tr>
    <tr><td><?= Html::a("Ver mas",["site/vermas", 'id' => $model->id], ['class' => 'btn btn-primary']) ?></td></tr>
    <hr>
    
</table>

views/site/about.php
<?php

/* @var $this yii\web\View */

use yii\helpers\Html;

$this->title = 'About';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-about">
    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        This is the About page. You may modify the following file to customize its content:
    </p>

    <code><?= __FILE__ ?></code>
</div>

views/site/categorias.php
<?php
use yii\bootstrap4\Html;

foreach($resultado as $objeto)
{
    echo Html::a($objeto->categoria, ['site/categoria2', 'categoria' => $objeto->categoria], ['class' => 'btn btn-primary']) . "<br><br>"; 
}

views/site/donde_estamos.php
<iframe src="https://www.google.com/maps/embed?pb=!1m18!1m12!1m3!1d2895.951665428506!2d-3.813916384281594!3d43.461606272816255!2m3!1f0!2f0!3f0!3m2!1i1024!2i768!4f13.1!3m3!1m2!1s0xd494bcc568fd8c3%3A0x7858c552ade0effc!2sAlpe%20Formaci%C3%B3n!5e0!3m2!1ses!2ses!4v1633951629286!5m2!1ses!2ses" width="800" height="600" style="border:0;" allowfullscreen="" loading="lazy"></iframe>

views/site/error.php
<?php

/* @var $this yii\web\View */
/* @var $name string */
/* @var $message string */
/* @var $exception Exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/error_1.php
<?php

/* @var $this yii\web\View */
/* @var $name string */
/* @var $message string */
/* @var $exception Exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/index.php
<?php

/* @var $this yii\web\View */

$this->title = 'Web productos';
use yii\bootstrap4\Html;
?>
<h1>Los mejores productos al mejor precio</h1>

<p>En esta web encontraras todo tipo de productos con unos excelentes precios y con las mejores ofertas.</p>

<?= Html::img('@web/img/imagen_index.png',['width' => 1000,'height' => 400]); ?>

views/site/informacion.php
<h1>Informacion</h1>

<p>At vero eos et accusamus et iusto odio dignissimos ducimus qui blanditiis praesentium voluptatum deleniti atque corrupti quos dolores et quas 
    molestias excepturi sint occaecati cupiditate non provident, similique sunt in culpa qui officia deserunt mollitia animi, id est laborum et dolorum fuga. 
    Et harum quidem rerum facilis est et expedita distinctio. Nam libero tempore, cum soluta nobis est eligendi optio cumque nihil impedit quo minus id quod 
    maxime placeat facere possimus, omnis voluptas assumenda est, omnis dolor repellendus. Temporibus autem quibusdam et aut officiis debitis aut rerum 
    necessitatibus saepe eveniet ut et voluptates repudiandae sint et molestiae non recusandae. Itaque earum rerum hic tenetur a sapiente delectus, 
    ut aut reiciendis voluptatibus maiores alias consequatur aut perferendis doloribus asperiores repellat.</p>

views/site/login.php
<?php

/* @var $this yii\web\View */
/* @var $form yii\bootstrap4\ActiveForm */
/* @var $model app\models\LoginForm */

use yii\bootstrap4\ActiveForm;
use yii\bootstrap4\Html;

$this->title = 'Login';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-login">
    <h1><?= Html::encode($this->title) ?></h1>

    <p>Please fill out the following fields to login:</p>

    <?php $form = ActiveForm::begin([
        'id' => 'login-form',
        'layout' => 'horizontal',
        'fieldConfig' => [
            'template' => "{label}\n<div class=\"col-lg-3\">{input}</div>\n<div class=\"col-lg-8\">{error}</div>",
            'labelOptions' => ['class' => 'col-lg-1 col-form-label'],
        ],
    ]); ?>

        <?= $form->field($model, 'username')->textInput(['autofocus' => true]) ?>

        <?= $form->field($model, 'password')->passwordInput() ?>

        <?= $form->field($model, 'rememberMe')->checkbox([
            'template' => "<div class=\"offset-lg-1 col-lg-3 custom-control custom-checkbox\">{input} {label}</div>\n<div class=\"col-lg-8\">{error}</div>",
        ]) ?>

        <div class="form-group">
            <div class="offset-lg-1 col-lg-11">
                <?= Html::submitButton('Login', ['class' => 'btn btn-primary', 'name' => 'login-button']) ?>
            </div>
        </div>

    <?php ActiveForm::end(); ?>

    <div class="offset-lg-1" style="color:#999;">
        You may login with <strong>admin/admin</strong> or <strong>demo/demo</strong>.<br>
        To modify the username/password, please check out the code <code>app\models\User::$users</code>.
    </div>
</div>

views/site/mostrar.php
Muchas gracias por ponerse en contacto con nosotros

views/site/nuestros_productos.php
<?php

use yii\bootstrap4\Carousel;
use yii\helpers\Html;

echo Carousel::widget([
    'items' => $fotos,
    'options'=>[
        'class' => 'mx-auto col-lg-8'
    ],
    'controls' => ['<i class="fas fa-arrow-left fa-3x"></i>','<i class="fas fa-arrow-right fa-3x"></i>']
]);

views/site/ofertas.php
<?php

use yii\widgets\ListView;

echo ListView::widget([
    'dataProvider' => $dataProvider,
    'itemView' => '_ofertas',
    ]);

?>

views/site/productos.php
<?php

use yii\grid\GridView;
use yii\bootstrap4\Html;

echo GridView::widget([
    'dataProvider' => $dataProvider,
    'columns' => [
        'id',
        'nombre',
        [
            'label'=>'Foto',
            'format'=>'raw',
            'value'=>function($data){
                $url='@web/img/' . $data->foto;
                return Html::img($url,['class'=>'img-fluid', 'style'=>'width:300px']);
            }
        ],
        [
            'label'=>'Precio',
            'value'=>function($data){
            return $data->precio . "€";
            }
        ],
        'oferta',
        'categoria',        
        
    ]]);

?>

views/site/quienes_somos.php
<h1>Quienes somos</h1>

<p>Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, 
    eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo. 
    Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit, sed quia consequuntur magni dolores eos qui ratione voluptatem sequi nesciunt. 
    Neque porro quisquam est, qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit, sed quia non numquam eius modi 
    tempora incidunt ut labore et dolore magnam aliquam quaerat voluptatem. Ut enim ad minima veniam, quis nostrum exercitationem 
    ullam corporis suscipit laboriosam, nisi ut aliquid ex ea commodi consequatur? Quis autem vel eum iure reprehenderit qui in ea 
    voluptate velit esse quam nihil molestiae consequatur, vel illum qui dolorem eum fugiat quo voluptas nulla pariatur</p>